#ifndef __LH5DEC_H__
#define __LH5DEC_H__

/*  Extract lh5 data */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	FALSE			0
#define TRUE			1
typedef int			boolean;


#if defined(__STDC__) || defined(AIX)

#include <limits.h>

#else

#ifndef CHAR_BIT
#define CHAR_BIT  8
#endif

#ifndef UCHAR_MAX
#define UCHAR_MAX				((1<<(sizeof(unsigned char)*8))-1)
#endif

#ifndef USHRT_MAX
#define USHRT_MAX				((1<<(sizeof(unsigned short)*8))-1)
#endif

#ifndef SHRT_MAX
#define SHRT_MAX				((1<<(sizeof(short)*8-1))-1)
#endif

#ifndef SHRT_MIN
#define SHRT_MIN				(SHRT_MAX-USHRT_MAX)
#endif

#ifndef ULONG_MAX
#define ULONG_MAX	((1<<(sizeof(unsigned long)*8))-1)
#endif

#ifndef LONG_MAX
#define LONG_MAX	((1<<(sizeof(long)*8-1))-1)
#endif

#ifndef LONG_MIN
#define LONG_MIN	(LONG_MAX-ULONG_MAX)
#endif

#endif	/* not __STDC__ */


/* from crcio.c */
//#define CRCPOLY			0xA001		/* CRC-16 */
#define UPDATE_CRC(c)	lh5->crc = lh5->crctable[(lh5->crc ^ (c)) & 0xFF] ^ (lh5->crc >> CHAR_BIT)

/* huf.c */
#define NP			(MAX_DICBIT + 1)
#define NT			(USHRT_BIT + 3)


//#define PBIT		4		/* smallest integer such that (1 << PBIT) > * NP */
//#define TBIT 		5		/* smallest integer such that (1 << TBIT) > * NT */
//#define PBIT		5		/* smallest integer such that (1 << PBIT) > * NP */
#define TBIT 		5		/* smallest integer such that (1 << TBIT) > * NT */


#define NC 			(UCHAR_MAX + MAXMATCH + 2 - THRESHOLD)

/*		#if NT > NP #define NPT NT #else #define NPT NP #endif	*/
#define NPT			0x80

#define MAX_DICBIT			15      /* lh6 use 15bits */

#define MAXMATCH			256	/* formerly F (not more than UCHAR_MAX + 1) */
#define THRESHOLD			3	/* choose optimal value */

/* alphabet = {0, 1, 2, ..., NC - 1} */
#define CBIT				9	/* $\lfloor \log_2 NC \rfloor + 1$ */
#define USHRT_BIT			16	/* (CHAR_BIT * sizeof(ushort)) */


typedef struct
{
  unsigned short  left[2 * NC - 1], right[2 * NC - 1];
  unsigned char   c_len[NC], pt_len[NPT];

  unsigned short  c_freq[2 * NC - 1], c_table[4096], c_code[NC], p_freq[2 * NP - 1],
                  pt_table[256], pt_code[NPT], t_freq[2 * NT - 1];
  /*static*/ unsigned short crctable[UCHAR_MAX + 1];
  /*static*/ unsigned char subbitbuf, bitcount;

  /*static*/ unsigned short blocksize;

// ALEX  ,   
  /*static*/ 	int	  pbit;
  /*static*/ 	int	  np;

  unsigned short crc, bitbuf;

// ALEX  
  /*static*/ unsigned long dicsiz;  /* t.okamoto */

  unsigned long count;
  unsigned long loc;
  unsigned long compsize;
  unsigned long origsize;

/*    -
      	 */
  unsigned char *in_buf;
  unsigned char *out_buf;
} lh5_decode_t;


void lh5_decode(lh5_decode_t *lh5, unsigned char *outp, unsigned char *inp, long packed_size, long original_size);

#endif /* __LH5DEC_H__ */

